#include <sstream>

#include "general/unittest.h"

General::UnitTest Test;

void
test_cur( )
{
  const char* test_dir = "/scratch/test/frames/bad";
  const char* files[] =
    { "L-R-991431920-16.gwf.bad",
      "L-R-991432112-16.gwf.bad",
      "L-R-991434112-16.gwf.bad"
    };
  const char** cur_file;
  const char** last_file;

  for ( cur_file = files,
        last_file = &(files[ 3 ]);
	cur_file != last_file;
	++cur_file )
  {
    {
      std::ostringstream	cmd_base;
      std::ostringstream	cmd;

      cmd_base << "./framecpp_verify_checksums"
	       << " " << test_dir << "/" << *cur_file
	;
      cmd << cmd_base.str( )
	  << " > /dev/null 2>&1"
	;
      
      int ret = system( cmd.str( ).c_str( ) );
      Test.Check( ret != 0 )
	<< ": file: " << test_dir << "/" << *cur_file
	<< " ret: " << ret
	<< " cmd: " << cmd_base.str( )
	<< std::endl
	;
    }
    {
      std::ostringstream	cmd_base;
      std::ostringstream	cmd;

      cmd_base << "./framecpp_verify"
	       << " -verbose"
	       << " " << test_dir << "/" << *cur_file
	;
      cmd << cmd_base.str( )
	  << " > /dev/null 2>&1"
	;
      
      int ret = system( cmd.str( ).c_str( ) );
      Test.Check( ret != 0 )
	<< ": file: " << test_dir << "/" << *cur_file
	<< " ret: " << ret
	<< " cmd: " << cmd_base.str( )
	<< std::endl
	;
    }
  }
}

int
main( int ArgC, char* ArgV[] )
try
{
  //---------------------------------------------------------------------
  // Setup
  //---------------------------------------------------------------------
  
  Test.Init( ArgC, ArgV );


  //---------------------------------------------------------------------
  // 
  //---------------------------------------------------------------------
  test_cur( );
  
  //---------------------------------------------------------------------
  // Exit
  //---------------------------------------------------------------------
  Test.Exit();
}
catch ( ... )
{
  //---------------------------------------------------------------------
  // Setup
  //---------------------------------------------------------------------
  
  Test.Check( false ) << "Caught an exception" << std::endl;

  //---------------------------------------------------------------------
  // Exit
  //---------------------------------------------------------------------
  Test.Exit( );
}
